#include "Module.h"
#include <iostream>
#include <dlfcn.h>
using namespace std;

Module * Module::load(const char * module_name)
{
	void * handle = 0;
	Module * module = 0;
	Module * (*creator)(void) = 0;
	const char * error = 0;

	// open module
	handle = dlopen(module_name, RTLD_NOW);
	if (!handle)
	{
		if ((error = dlerror()) != 0) cerr << error << endl;
		return 0;
	}

	// link factory method
	creator = (Module *(*)(void))dlsym(handle, "create_module");
	if (!creator)
	{
		if ((error = dlerror()) != 0)
		{
			cerr << error << endl;
			return 0;
		}
	}

	// create object and return it
	module = (*creator)();
	module->handle = handle;
	return module;
}

bool Module::unload(Module * module)
{
	// destroy object and close module
	if (!module) return false;
	void * handle = module->handle;
	delete module;
	dlclose(handle);
	return true;
}
